;--------------- AUTOMATIC-DIALOG OPS ------------------------------------

(defun alert-dialog (title text h v)
  (let* ((item00 (make-dialog-item 'static-text-dialog-item  #@(5 5) (make-point (- h 90) (- v 43)) text))
         (item01 (make-dialog-item      'button-dialog-item  (make-point (- h 75) (- v 33)) #@(60 18) "OK"  #'(lambda (item) item (return-from-modal-dialog nil)) :default-button t))
         (dialog (make-instance 'color-dialog :view-size     (make-point h v)
                                              :auto-position :CenterParentWindowScreen
                                              :back-color    *dialog-color*
                                              :window-type   :movable-dialog
                                              :window-title  title
                                              :view-subviews (list item00 item01))))
    (modal-dialog dialog)))

(defmethod save?-dialog ((window logoblocks-window))
  (if *save-flag* (let ((result (catch-cancel (y-or-n-dialog "Save before proceeding?"
                                                             :size #@(290 120)))))
                    (if (eq result :cancel) nil
                                            (progn (if result (save-file window))
                                                   t)))
                  t))

;--------------- REQUESTABLE-DIALOG OPS ------------------------------------

(defun about-dialog ()
  (let* ((item00 (  make-pict-item (nth 75 *pict-buffers*)   #@(  0   0)))
         (item01 (make-dialog-item 'static-text-dialog-item  #@( 10 220) #@(250 16) "Written in Macintosh Common Lisp."))
         (item02 (make-dialog-item      'button-dialog-item  #@(145 256) #@( 60 18) "OK" #'(lambda (item) item (return-from-modal-dialog nil)) :default-button t))
         (dialog (make-instance 'color-dialog :view-size     #@(350 290)
                                              :auto-position :CenterParentWindowScreen
                                              :window-type   :double-edge-box
                                              :view-subviews (list item00 item01 item02))))
    (modal-dialog dialog)))

(defmethod preferences-dialog ((window logoblocks-window))
  (let* ((index1 *default-project-mode*)
         (index2 *current-window-size*)
         (index3 *size-borders-flag*)
         (item00 (make-dialog-item  'static-text-dialog-item #@( 10  10) #@(150 16) "Configure For:"))
         (item01 (make-dialog-item 'radio-button-dialog-item #@( 20  28) #@(150 16) "Red Dot Crickets"               #'(lambda (item) item (setf index1 1))                            :radio-button-cluster 1 :radio-button-pushed-p (= index1 1)))
         (item02 (make-dialog-item 'radio-button-dialog-item #@( 20  46) #@(150 16) "Blue Dot Crickets"              #'(lambda (item) item (setf index1 2))                            :radio-button-cluster 1 :radio-button-pushed-p (= index1 2)))
         (item03 (make-dialog-item 'radio-button-dialog-item #@( 20  64) #@(150 16) "LEGO RCX Bricks"                #'(lambda (item) item (setf index1 3)) :dialog-item-enabled-p nil :radio-button-cluster 1 :radio-button-pushed-p (= index1 3)))
         (item04 (make-dialog-item  'static-text-dialog-item #@(170  10) #@(220 16) (cond ((= *default-window-size* 1) "Current Default: 640 x 480")
                                                                                          ((= *default-window-size* 2) "Current Default: 800 x 600")
                                                                                          ((= *default-window-size* 3) "Current Default: 1024 x 768"))))
         (item05 (make-dialog-item  'static-text-dialog-item #@(170  54) #@(100 16) "Window Fills a"))
         (item06 (make-dialog-item 'radio-button-dialog-item #@(274  36) #@( 86 16)  "640 x 480"                     #'(lambda (item) item (setf index2 1)) :radio-button-cluster 2 :radio-button-pushed-p (= index2 1)))
         (item07 (make-dialog-item 'radio-button-dialog-item #@(274  54) #@( 86 16)  "800 x 600"                     #'(lambda (item) item (setf index2 2)) :radio-button-cluster 2 :radio-button-pushed-p (= index2 2)))
         (item08 (make-dialog-item 'radio-button-dialog-item #@(274  72) #@( 86 16) "1024 x 768"                     #'(lambda (item) item (setf index2 3)) :radio-button-cluster 2 :radio-button-pushed-p (= index2 3)))
         (item09 (make-dialog-item  'static-text-dialog-item #@(364  54) #@( 50 16) "Screen"))
         (item10 (make-dialog-item       'button-dialog-item #@(170  98) #@(244 18) "Set Default"                    #'(lambda (item) item (unless (= index2 *default-window-size*)
                                                                                                                                             (setf *default-window-size* index2)
                                                                                                                                             (set-dialog-item-text item04 (cond ((= *default-window-size* 1) "Current Default: 640 x 480")
                                                                                                                                                                                ((= *default-window-size* 2) "Current Default: 800 x 600")
                                                                                                                                                                                ((= *default-window-size* 3) "Current Default: 1024 x 768"))))) :default-button nil))
         (item11 (make-dialog-item    'check-box-dialog-item #@(170 126) #@(244 16) "Display Window-Size Partitions" #'(lambda (item) item (if (= index3 0) (setf index3 1) (setf index3 0))) :check-box-checked-p (not (= index3 0))))
         (item12 (make-dialog-item       'button-dialog-item #@(182 158) #@( 60 18) "OK"                             #'(lambda (item) item (return-from-modal-dialog nil)) :default-button t))
         (dialog (make-instance 'color-dialog :view-size     #@(424 192)
                                              :auto-position :CenterParentWindowScreen
                                              :back-color    *dialog-color*
                                              :window-type   :movable-dialog
                                              :window-title  "Preferences"
                                              :view-subviews (list item00 item01 item02 item03 item04 item05 item06 item07 item08 item09 item10 item11 item12))))
    (modal-dialog dialog)
    (if (not (= index1 *default-project-mode*))
      (progn (setf *default-project-mode* index1)
             (rebuild-examples-menu)))
    (if (= index2 *current-window-size*)
      (if (not (= index3 *size-borders-flag*))
        (progn (setf *size-borders-flag* index3)
               (draw-buffer3       (wrkarea window) nil nil)
               (view-draw-contents (wrkarea window))))
      (progn (setf *current-window-size* index2)
             (setf *size-borders-flag*   index3)
             (let ((switch     (switch     (buttons   window)))
                   (blocklist1 (masterlist (palette   window)))
                   (blocklist2 (masterlist (wrkarea   window))))
               (dispose-record (windowrect            window))
               (dispose-record (hybridrect            window))
               (dispose-record ( localrect (buttons   window)))
               (dispose-record (globalrect (buttons   window)))
               (loop for x in (first-n-integers 5) do
                     (dispose-record (aref (controls (buttons window)) x)))
               (dispose-record ( localrect (palette   window)))
               (dispose-record (globalrect (palette   window)))
               (dispose-record (offsetrect (palette   window)))
               (dispose-record ( localrect (wrkarea   window)))
               (dispose-record (globalrect (wrkarea   window)))
               (dispose-record (offsetrect (wrkarea   window)))
               (dispose-record ( localrect (scrollbar window)))
               (dispose-record (globalrect (scrollbar window)))
               (dispose-gworld    (buffer3            window))
               (dispose-gworld    (buffer4            window))
               (dispose-gworld    (buffer1 (palette   window)))
               (dispose-gworld    (buffer2 (palette   window)))
               (dispose-gworld    (buffer1 (wrkarea   window)))
               (dispose-gworld    (buffer2 (wrkarea   window)))
               (window-close                          window)
               (create-logoblocks-window switch blocklist1 blocklist2))))
    (write-preferences)))

(defun monitor-dialog ()
  (let ((offset 0)
        (result (write-sensor-feeds)))
    (if (= result 0)
      (let* ((item00 (make-dialog-item 'radio-button-dialog-item #@( 10  10) #@(130 16) "Monitor Sensor A"  #'(lambda (item) item (setf offset 0)) :radio-button-cluster 1 :radio-button-pushed-p t))
             (item01 (make-dialog-item 'radio-button-dialog-item #@( 10  28) #@(130 16) "Monitor Sensor B"  #'(lambda (item) item (setf offset 3)) :radio-button-cluster 1 :radio-button-pushed-p nil))
             (item02 (make-dialog-item 'static-text-dialog-item  #@( 10  51) #@( 50 16) "Value:"))
             (item03 (make-dialog-item 'static-text-dialog-item  #@( 58  51) #@(106 16) "Setting Up..."))
             (item04 (make-dialog-item      'button-dialog-item  #@( 57  83) #@( 60 18) "OK" #'(lambda (item) item (return-from-modal-dialog nil)) :default-button t))
             (dialog (make-instance 'color-dialog :view-size     #@(174 117)
                                                  :auto-position :CenterParentWindowScreen
                                                  :back-color    *dialog-color*
                                                  :window-type   :double-edge-box
                                                  :view-subviews (list item00 item01 item02 item03 item04)))
             (eventhook #'(lambda () (let ((value (get-sensor-value offset)))
                                       (set-dialog-item-text item03 (cond ((= value -5) "No Transmission")
                                                                          ((= value -4) "No Interface")
                                                                          ((= value -3) "No Interface")
                                                                          ((= value -2) "Interface Off")
                                                                          ((= value -1) "No Crickets")
                                                                          ((>= value 0) (format nil "~S" value))))))))
        (modal-dialog dialog t eventhook))
      (download-message result))))

(defmethod flipside-dialog ((view wrkarea-view) (block on/off-block))
  (let* ((index1 (if (motorA? block) (if (motorB? block) 1 2) 3))
         (index2 (command block))
         (item00 (make-dialog-item 'radio-button-dialog-item #@( 10  10) #@(98 16) "Both Motors"  #'(lambda (item) item (setf index1 1)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 1)))
         (item01 (make-dialog-item 'radio-button-dialog-item #@( 10  28) #@(98 16) "Motor A Only" #'(lambda (item) item (setf index1 2)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 2)))
         (item02 (make-dialog-item 'radio-button-dialog-item #@( 10  46) #@(98 16) "Motor B Only" #'(lambda (item) item (setf index1 3)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 3)))
         (item03 (make-dialog-item 'radio-button-dialog-item #@(126  10) #@(58 16) "On"           #'(lambda (item) item (setf index2 1)) :radio-button-cluster 2 :radio-button-pushed-p (= index2 1)))
         (item04 (make-dialog-item 'radio-button-dialog-item #@(126  28) #@(58 16) "Off"          #'(lambda (item) item (setf index2 2)) :radio-button-cluster 2 :radio-button-pushed-p (= index2 2)))
         (item05 (make-dialog-item 'radio-button-dialog-item #@(126  46) #@(58 16) "Brake"        #'(lambda (item) item (setf index2 3)) :radio-button-cluster 2 :radio-button-pushed-p (= index2 3)))
         (item06 (make-dialog-item       'button-dialog-item #@( 67  78) #@(60 18) "OK"           #'(lambda (item) item (return-from-modal-dialog nil)) :default-button t))
         (dialog (make-instance 'color-dialog :view-size     #@(194 112)
                                              :auto-position :CenterParentWindowScreen
                                              :back-color    *dialog-color*
                                              :window-type   :movable-dialog
                                              :window-title  "Block Specifications"
                                              :view-subviews (list item00 item01 item02 item03 item04 item05 item06))))
    (modal-dialog dialog)
    (cond ((= index1 1) (setf (motorA? block) t)
                        (setf (motorB? block) t))
          ((= index1 2) (setf (motorA? block) t)
                        (setf (motorB? block) nil))
          ((= index1 3) (setf (motorA? block) nil)
                        (setf (motorB? block) t)))
    (setf (command block) index2)
    (draw-buffer3       view (list block) 'draw)
    (view-draw-contents view)))

(defmethod flipside-dialog ((view wrkarea-view) (block direction-block))
  (let* ((index1 (if (motorA? block) (if (motorB? block) 1 2) 3))
         (index2 (command block))
         (item00 (make-dialog-item 'radio-button-dialog-item #@( 10  10) #@( 98 16) "Both Motors"       #'(lambda (item) item (setf index1 1)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 1)))
         (item01 (make-dialog-item 'radio-button-dialog-item #@( 10  28) #@( 98 16) "Motor A Only"      #'(lambda (item) item (setf index1 2)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 2)))
         (item02 (make-dialog-item 'radio-button-dialog-item #@( 10  46) #@( 98 16) "Motor B Only"      #'(lambda (item) item (setf index1 3)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 3)))
         (item03 (make-dialog-item 'radio-button-dialog-item #@(126  10) #@( 80 16) "This Way"          #'(lambda (item) item (setf index2 1)) :radio-button-cluster 2 :radio-button-pushed-p (= index2 1)))
         (item04 (  make-pict-item (nth 73 *pict-buffers*)   #@(208  12)))
         (item05 (make-dialog-item 'radio-button-dialog-item #@(126  28) #@( 80 16) "That Way"          #'(lambda (item) item (setf index2 2)) :radio-button-cluster 2 :radio-button-pushed-p (= index2 2)))
         (item06 (  make-pict-item (nth 74 *pict-buffers*)   #@(208  30)))
         (item07 (make-dialog-item 'radio-button-dialog-item #@(126  46) #@(132 16) "Reverse Direction" #'(lambda (item) item (setf index2 3)) :radio-button-cluster 2 :radio-button-pushed-p (= index2 3)))
         (item08 (make-dialog-item       'button-dialog-item #@(104  78) #@( 60 18) "OK"                #'(lambda (item) item (return-from-modal-dialog nil)) :default-button t))
         (dialog (make-instance 'color-dialog :view-size     #@(268 112)
                                              :auto-position :CenterParentWindowScreen
                                              :back-color    *dialog-color*
                                              :window-type   :movable-dialog
                                              :window-title  "Block Specifications"
                                              :view-subviews (list item00 item01 item02 item03 item04 item05 item06 item07 item08))))
    (modal-dialog dialog)
    (cond ((= index1 1) (setf (motorA? block) t)
                        (setf (motorB? block) t))
          ((= index1 2) (setf (motorA? block) t)
                        (setf (motorB? block) nil))
          ((= index1 3) (setf (motorA? block) nil)
                        (setf (motorB? block) t)))
    (setf (command block) index2)
    (draw-buffer3       view (list block) 'draw)
    (view-draw-contents view)))

(defmethod flipside-dialog ((view wrkarea-view) (block power-block))
  (let* ((index1 (if (motorA? block) (if (motorB? block) 1 2) 3))
         (index2 (command block))
         (item00 (make-dialog-item 'radio-button-dialog-item #@( 10  10) #@(98 16) "Both Motors"  #'(lambda (item) item (setf index1 1)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 1)))
         (item01 (make-dialog-item 'radio-button-dialog-item #@( 10  28) #@(98 16) "Motor A Only" #'(lambda (item) item (setf index1 2)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 2)))
         (item02 (make-dialog-item 'radio-button-dialog-item #@( 10  46) #@(98 16) "Motor B Only" #'(lambda (item) item (setf index1 3)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 3)))
         (item03 (make-dialog-item 'radio-button-dialog-item #@(126  10) #@(34 16) "1"            #'(lambda (item) item (setf index2 1)) :radio-button-cluster 2 :radio-button-pushed-p (= index2 1)))
         (item04 (make-dialog-item 'radio-button-dialog-item #@(126  28) #@(34 16) "2"            #'(lambda (item) item (setf index2 2)) :radio-button-cluster 2 :radio-button-pushed-p (= index2 2)))
         (item05 (make-dialog-item 'radio-button-dialog-item #@(126  46) #@(34 16) "3"            #'(lambda (item) item (setf index2 3)) :radio-button-cluster 2 :radio-button-pushed-p (= index2 3)))
         (item06 (make-dialog-item 'radio-button-dialog-item #@(126  64) #@(34 16) "4"            #'(lambda (item) item (setf index2 4)) :radio-button-cluster 2 :radio-button-pushed-p (= index2 4)))
         (item07 (make-dialog-item 'radio-button-dialog-item #@(126  82) #@(34 16) "5"            #'(lambda (item) item (setf index2 5)) :radio-button-cluster 2 :radio-button-pushed-p (= index2 5)))
         (item08 (make-dialog-item 'radio-button-dialog-item #@(126 100) #@(34 16) "6"            #'(lambda (item) item (setf index2 6)) :radio-button-cluster 2 :radio-button-pushed-p (= index2 6)))
         (item09 (make-dialog-item 'radio-button-dialog-item #@(126 118) #@(34 16) "7"            #'(lambda (item) item (setf index2 7)) :radio-button-cluster 2 :radio-button-pushed-p (= index2 7)))
         (item10 (make-dialog-item 'radio-button-dialog-item #@(126 136) #@(34 16) "8"            #'(lambda (item) item (setf index2 8)) :radio-button-cluster 2 :radio-button-pushed-p (= index2 8)))
         (item11 (make-dialog-item       'button-dialog-item #@( 55 168) #@(60 18) "OK"           #'(lambda (item) item (return-from-modal-dialog nil)) :default-button t))
         (dialog (make-instance 'color-dialog :view-size     #@(170 202)
                                              :auto-position :CenterParentWindowScreen
                                              :back-color    *dialog-color*
                                              :window-type   :movable-dialog
                                              :window-title  "Block Specifications"
                                              :view-subviews (list item00 item01 item02 item03 item04 item05 item06 item07 item08 item09 item10 item11))))
    (modal-dialog dialog)
    (cond ((= index1 1) (setf (motorA? block) t)
                        (setf (motorB? block) t))
          ((= index1 2) (setf (motorA? block) t)
                        (setf (motorB? block) nil))
          ((= index1 3) (setf (motorA? block) nil)
                        (setf (motorB? block) t)))
    (setf (command block) index2)
    (draw-buffer3       view (list block) 'draw)
    (view-draw-contents view)))

(defmethod flipside-dialog ((view wrkarea-view) (block onfor-block))
  (let* ((index1 (if (motorA? block) (if (motorB? block) 1 2) 3))
         (item00 (make-dialog-item  'radio-button-dialog-item #@( 10  10) #@(98 16) "Both Motors"  #'(lambda (item) item (setf index1 1)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 1)))
         (item01 (make-dialog-item  'radio-button-dialog-item #@( 10  28) #@(98 16) "Motor A Only" #'(lambda (item) item (setf index1 2)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 2)))
         (item02 (make-dialog-item  'radio-button-dialog-item #@( 10  46) #@(98 16) "Motor B Only" #'(lambda (item) item (setf index1 3)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 3)))
         (item03 (make-dialog-item        'button-dialog-item #@( 29  78) #@(60 18) "OK"           #'(lambda (item) item (return-from-modal-dialog nil)) :default-button t))
         (dialog (make-instance 'color-dialog :view-size      #@(118 112)
                                              :auto-position  :CenterParentWindowScreen
                                              :back-color     *dialog-color*
                                              :window-type    :movable-dialog
                                              :window-title   "Block Specifications"
                                              :view-subviews  (list item00 item01 item02 item03))))
    (modal-dialog dialog)
    (cond ((= index1 1) (setf (motorA? block) t)
                        (setf (motorB? block) t))
          ((= index1 2) (setf (motorA? block) t)
                        (setf (motorB? block) nil))
          ((= index1 3) (setf (motorA? block) nil)
                        (setf (motorB? block) t)))
    (draw-buffer3       view (list block) 'draw)
    (view-draw-contents view)))

(defmethod flipside-dialog ((view wrkarea-view) (block beep-block))
  ())

(defmethod flipside-dialog ((view wrkarea-view) (block note-block))
  (let* ((index1    (modifier block))
         (index2    (octave   block))
         (menuitems (list (make-instance 'menu-item :menu-item-title "A")
                          (make-instance 'menu-item :menu-item-title "B")
                          (make-instance 'menu-item :menu-item-title "C")
                          (make-instance 'menu-item :menu-item-title "D")
                          (make-instance 'menu-item :menu-item-title "E")
                          (make-instance 'menu-item :menu-item-title "F")
                          (make-instance 'menu-item :menu-item-title "G")))
         (item00 (make-instance 'pop-up-menu  :view-size     #@(55 20)
                                              :view-position #@(10 26)
                                              :default-item  (pitch block)
                                              :menu-items    menuitems))
         (item01 (make-dialog-item  'radio-button-dialog-item #@( 75  10) #@(70 16) "Sharp"    #'(lambda (item) item (setf index1 1)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 1)))
         (item02 (make-dialog-item  'radio-button-dialog-item #@( 75  28) #@(70 16) "Natural"  #'(lambda (item) item (setf index1 2)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 2)))
         (item03 (make-dialog-item  'radio-button-dialog-item #@( 75  46) #@(70 16) "Flat"     #'(lambda (item) item (setf index1 3)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 3)))
         (item04 (make-dialog-item  'radio-button-dialog-item #@(149  10) #@(75 16) "(High)"   #'(lambda (item) item (setf index2 1)) :radio-button-cluster 2 :radio-button-pushed-p (= index2 1)))
         (item05 (make-dialog-item  'radio-button-dialog-item #@(149  28) #@(75 16) "(Middle)" #'(lambda (item) item (setf index2 2)) :radio-button-cluster 2 :radio-button-pushed-p (= index2 2)))
         (item06 (make-dialog-item  'radio-button-dialog-item #@(149  46) #@(75 16) "(Low)"    #'(lambda (item) item (setf index2 3)) :radio-button-cluster 2 :radio-button-pushed-p (= index2 3)))
         (item07 (make-dialog-item        'button-dialog-item #@( 87  78) #@(60 18) "OK"       #'(lambda (item) item (return-from-modal-dialog nil)) :default-button t))
         (dialog (make-instance 'color-dialog :view-size      #@(234 112)
                                              :auto-position  :CenterParentWindowScreen
                                              :back-color     *dialog-color*
                                              :window-type    :movable-dialog
                                              :window-title   "Block Specifications"
                                              :view-subviews  (list item00 item01 item02 item03 item04 item05 item06 item07))))
    (modal-dialog dialog)
    (setf (pitch    block) (popup-selection menuitems))
    (setf (modifier block) index1)
    (setf (octave   block) index2)
    (draw-buffer3       view (list block) 'draw)
    (view-draw-contents view)))

(defmethod flipside-dialog ((view wrkarea-view) (block wait-block))
  ())

(defmethod flipside-dialog ((view wrkarea-view) (block zerotimer-block))
  ())

(defmethod flipside-dialog ((view wrkarea-view) (block timer-block))
  ())

(defmethod flipside-dialog ((view wrkarea-view) (block dummy-block))
  ())

(defmethod flipside-dialog ((view wrkarea-view) (block when-block))
  ())

(defmethod flipside-dialog ((view wrkarea-view) (block whenoff-block))
  ())

(defmethod flipside-dialog ((view wrkarea-view) (block if-block))
  ())

(defmethod flipside-dialog ((view wrkarea-view) (block ifelse-block))
  ())

(defmethod flipside-dialog ((view wrkarea-view) (block repeat-block))
  ())

(defmethod flipside-dialog ((view wrkarea-view) (block loop-block))
  ())

(defmethod flipside-dialog ((view wrkarea-view) (block waituntil-block))
  ())

(defmethod flipside-dialog ((view wrkarea-view) (block switch-block))
  (let* ((index1 (switch block))
         (item00 (make-dialog-item 'radio-button-dialog-item #@(10 10) #@(76 16) "Switch A" #'(lambda (item) item (setf index1 1)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 1)))
         (item01 (make-dialog-item 'radio-button-dialog-item #@(10 28) #@(76 16) "Switch B" #'(lambda (item) item (setf index1 2)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 2)))
         (item02 (make-dialog-item       'button-dialog-item #@(18 60) #@(60 18) "OK"       #'(lambda (item) item (return-from-modal-dialog nil)) :default-button t))
         (dialog (make-instance 'color-dialog :view-size     #@(96 94)
                                              :auto-position :CenterParentWindowScreen
                                              :back-color    *dialog-color*
                                              :window-type   :movable-dialog
                                              :window-title  "Block Specifications"
                                              :view-subviews (list item00 item01 item02))))
    (modal-dialog dialog)
    (setf (switch block) index1)
    (draw-buffer3       view (list block) 'draw)
    (view-draw-contents view)))

(defmethod flipside-dialog ((view wrkarea-view) (block sensor-block))
  (let* ((index1 (sensor block))
         (item00 (make-dialog-item 'radio-button-dialog-item #@(10 10) #@(76 16) "Sensor A" #'(lambda (item) item (setf index1 1)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 1)))
         (item01 (make-dialog-item 'radio-button-dialog-item #@(10 28) #@(76 16) "Sensor B" #'(lambda (item) item (setf index1 2)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 2)))
         (item02 (make-dialog-item       'button-dialog-item #@(18 60) #@(60 18) "OK"       #'(lambda (item) item (return-from-modal-dialog nil)) :default-button t))
         (dialog (make-instance 'color-dialog :view-size     #@(96 94)
                                              :auto-position :CenterParentWindowScreen
                                              :back-color    *dialog-color*
                                              :window-type   :movable-dialog
                                              :window-title  "Block Specifications"
                                              :view-subviews (list item00 item01 item02))))
    (modal-dialog dialog)
    (setf (sensor block) index1)
    (draw-buffer3       view (list block) 'draw)
    (view-draw-contents view)))

(defmethod flipside-dialog ((view wrkarea-view) (block clearir-block))
  ())

(defmethod flipside-dialog ((view wrkarea-view) (block newir?-block))
  ())

(defmethod flipside-dialog ((view wrkarea-view) (block ir-block))
  ())

(defmethod flipside-dialog ((view wrkarea-view) (block sendir-block))
  ())

(defmethod flipside-dialog ((view wrkarea-view) (block display-block))
  (let* ((index1 (color block))
         (item00 (make-dialog-item 'radio-button-dialog-item #@(10  10) #@(66 16) "Red"    #'(lambda (item) item (setf index1 1)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 1)))
         (item01 (make-dialog-item 'radio-button-dialog-item #@(10  28) #@(66 16) "Blue"   #'(lambda (item) item (setf index1 2)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 2)))
         (item02 (make-dialog-item 'radio-button-dialog-item #@(10  46) #@(66 16) "Yellow" #'(lambda (item) item (setf index1 3)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 3)))
         (item03 (make-dialog-item 'radio-button-dialog-item #@(10  64) #@(66 16) "White"  #'(lambda (item) item (setf index1 4)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 4)))
         (item04 (make-dialog-item       'button-dialog-item #@(13  96) #@(60 18) "OK"     #'(lambda (item) item (return-from-modal-dialog nil)) :default-button t))
         (dialog (make-instance 'color-dialog :view-size     #@(86 130)
                                              :auto-position :CenterParentWindowScreen
                                              :back-color    *dialog-color*
                                              :window-type   :movable-dialog
                                              :window-title  "Block Specifications"
                                              :view-subviews (list item00 item01 item02 item03 item04))))
    (modal-dialog dialog)
    (setf (color block) index1)
    (draw-buffer3       view (list block) 'draw)
    (view-draw-contents view)))

(defmethod flipside-dialog ((view wrkarea-view) (block number-block))
  (let* ((index1 (genmethod block))
         (numstr (format nil "~S" (value      block)))
         (lwbstr (format nil "~S" (lowerbound block)))
         (upbstr (format nil "~S" (upperbound block)))
         (item00 (make-dialog-item  'radio-button-dialog-item #@( 10 15) #@( 15 16) ""                 #'(lambda (item) item (setf index1 1)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 1)))
         (item01 (make-dialog-item 'editable-text-dialog-item #@( 32 15) #@( 42 16) numstr             #'(lambda (item)      (unless (= index1 1) (radio-button-push item00) (setf index1 1)) (setf numstr (dialog-item-text item))) :allow-returns nil :draw-outline t))
         (item02 (make-dialog-item  'radio-button-dialog-item #@( 10 43) #@(133 16) "Random Between: " #'(lambda (item) item (setf index1 2)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 2)))
         (item03 (make-dialog-item 'editable-text-dialog-item #@(150 43) #@( 42 16) lwbstr             #'(lambda (item)      (unless (= index1 2) (radio-button-push item02) (setf index1 2)) (setf lwbstr (dialog-item-text item))) :allow-returns nil :draw-outline t))
         (item04 (make-dialog-item   'static-text-dialog-item #@(199 43) #@( 27 16) "and"))
         (item05 (make-dialog-item 'editable-text-dialog-item #@(233 43) #@( 42 16) upbstr             #'(lambda (item)      (unless (= index1 2) (radio-button-push item02) (setf index1 2)) (setf upbstr (dialog-item-text item))) :allow-returns nil :draw-outline t))
         (item06 (make-dialog-item        'button-dialog-item #@(115 80) #@( 60 18) "OK"               #'(lambda (item) item (if (or (not (valid-number? numstr))
                                                                                                                                     (not (valid-number? lwbstr))
                                                                                                                                     (not (valid-number? upbstr)))
                                                                                                                               (bad-number-error)
                                                                                                                               (if (> (read-from-string lwbstr)
                                                                                                                                      (read-from-string upbstr))
                                                                                                                                 (bound-reversal-error)
                                                                                                                                 (return-from-modal-dialog nil)))) :default-button t))
         (dialog (make-instance 'color-dialog :view-size      #@(290 114)
                                              :auto-position  :CenterParentWindowScreen
                                              :back-color     *dialog-color*
                                              :window-type    :movable-dialog
                                              :window-title   "Block Specifications"
                                              :view-subviews  (list item00 item01 item02 item03 item04 item05 item06))))
    (modal-dialog dialog)
    (setf (genmethod  block) index1)
    (setf (value      block) (read-from-string numstr))
    (setf (lowerbound block) (read-from-string lwbstr))
    (setf (upperbound block) (read-from-string upbstr))
    (draw-buffer3       view (list block) 'draw)
    (view-draw-contents view)))

(defmethod flipside-dialog ((view wrkarea-view) (block boolean-block))
  (let* ((index1 (comparator block))
         (item00 (make-dialog-item 'radio-button-dialog-item #@(25  10) #@(30 16) "<"  #'(lambda (item) item (setf index1 1)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 1)))
         (item01 (make-dialog-item 'radio-button-dialog-item #@(25  28) #@(30 16) "="  #'(lambda (item) item (setf index1 2)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 2)))
         (item02 (make-dialog-item 'radio-button-dialog-item #@(25  46) #@(30 16) ">"  #'(lambda (item) item (setf index1 3)) :radio-button-cluster 1 :radio-button-pushed-p (= index1 3)))
         (item03 (make-dialog-item       'button-dialog-item #@(10  78) #@(60 18) "OK" #'(lambda (item) item (return-from-modal-dialog nil)) :default-button t))
         (dialog (make-instance 'color-dialog :view-size     #@(80 112)
                                              :auto-position :CenterParentWindowScreen
                                              :back-color    *dialog-color*
                                              :window-type   :movable-dialog
                                              :window-title  "Block Specifications"
                                              :view-subviews (list item00 item01 item02 item03))))
    (modal-dialog dialog)
    (setf (comparator block) index1)
    (draw-buffer3       view (list block) 'draw)
    (view-draw-contents view)))

(defmethod flipside-dialog ((view wrkarea-view) (block and-block))
  ())

(defmethod flipside-dialog ((view wrkarea-view) (block or-block))
  ())

(defmethod flipside-dialog ((view wrkarea-view) (block cleardata-block))
  ())

(defmethod flipside-dialog ((view wrkarea-view) (block record-block))
  ())

(defmethod flipside-dialog ((view wrkarea-view) (block resetdp-block))
  ())

(defmethod flipside-dialog ((view wrkarea-view) (block defproc-block))
  (if (or (= (procnum block) 1)
          (= (procnum block) 2))
    (procedure-error -3)
    (let* ((proctitle (proctitle block))
           (item00    (make-dialog-item   'static-text-dialog-item #@( 10 15) #@(214 16) "Enter a name for this procedure:"))
           (item01    (make-dialog-item 'editable-text-dialog-item #@(231 15) #@( 62 16) proctitle #'(lambda (item)      (setf proctitle (dialog-item-text item))) :allow-returns nil :draw-outline t))
           (item02    (make-dialog-item        'button-dialog-item #@(124 52) #@( 60 18) "OK"      #'(lambda (item) item (if (or (equal proctitle (proctitle block))
                                                                                                                                 (valid-proctitle? view proctitle))
                                                                                                                           (return-from-modal-dialog nil)
                                                                                                                           (if (equal proctitle "")
                                                                                                                             (procedure-error -1)
                                                                                                                             (procedure-error -2)))) :default-button t))
           (dialog    (make-instance 'color-dialog :view-size      #@(308 86)
                                                   :auto-position  :CenterParentWindowScreen
                                                   :back-color     *dialog-color*
                                                   :window-type    :movable-dialog
                                                   :window-title   "Block Specifications"
                                                   :view-subviews  (list item00 item01 item02))))
      (modal-dialog dialog)
      (setf (proctitle block) proctitle)
      (draw-buffer3 view (list block) 'draw)
      (if (= (switch (buttons (view-container view))) 3)
        (progn (loop for scan in (masterlist (palette (view-container view))) do
                     (if (equal (species scan) 'callproc)
                       (if (= (procnum scan)
                              (procnum block))
                         (progn (setf (proctitle scan) (proctitle block))
                                (draw-buffer3 (palette (view-container view)) (list scan) 'draw)))))
               (view-draw-contents (palette (view-container view)))))
      (loop for scan in (masterlist view) do
            (if (equal (species scan) 'callproc)
              (if (= (procnum scan)
                     (procnum block))
                (progn (setf (proctitle scan) (proctitle block))
                       (draw-buffer3 view (list scan) 'draw)))))
      (view-draw-contents view))))

(defmethod flipside-dialog ((view wrkarea-view) (block stop-block))
  ())

(defmethod flipside-dialog ((view wrkarea-view) (block callproc-block))
  (let ((menuitems (list (make-instance 'menu-item :menu-item-title "None")
                         (make-instance 'menu-item :menu-item-title "P1")))
        (P2-flag   (if (index-defproc-block view 2) t nil)))
    (if P2-flag (setf menuitems (append menuitems (list (make-instance 'menu-item :menu-item-title "P2")))))
    (loop for scan in (masterlist view) do
          (if (equal (species scan) 'defproc)
            (if (> (procnum scan) 2)
              (setf menuitems (append menuitems (list (make-instance 'menu-item :menu-item-title (proctitle scan))))))))
    (let* ((item00 (make-instance 'pop-up-menu  :view-size     #@(100 20)
                                                :view-position #@( 10 10)
                                                :default-item  (+ (procnum block)
                                                                  (if (< (procnum block) 3) 1 (if P2-flag 1 0)))
                                                :menu-items    menuitems))
           (item01 (make-dialog-item 'button-dialog-item #@(30 46) #@(60 18) "OK" #'(lambda (item) item (return-from-modal-dialog nil)) :default-button t))
           (dialog (make-instance 'color-dialog :view-size     #@(120 80)
                                                :auto-position :CenterParentWindowScreen
                                                :back-color    *dialog-color*
                                                :window-type   :movable-dialog
                                                :window-title  "Block Specifications"
                                                :view-subviews (list item00 item01))))
      (modal-dialog dialog)
      (setf (procnum   block) (- (popup-selection menuitems)
                                 (if (< (popup-selection menuitems) 3) 1 (if P2-flag 1 0))))
      (setf (proctitle block) (if (> (procnum block) 0) (proctitle (index-defproc-block view (procnum block))) "None"))
      (draw-buffer3       view (list block) 'draw)
      (view-draw-contents view))))

;---------------

(defun make-pict-item (buffer position)
  (make-instance 'pict-dialog-item :view-position    position
                                   :view-size        (rect-size (access-gworld-boundrect buffer))
                                   :dialog-item-text ""
                                   :buffer           buffer))

(defun popup-selection (menuitems)
  (let ((x      0)
        (result nil))
    (loop for scan in menuitems do
          (setf x (+ x 1))
          (if (menu-item-check-mark scan)
            (setf result x)))
    result))

(defun valid-number? (numstr)
  (cond ((= *active-project-mode* 1) (check-numstr numstr 3 0   255))
        ((= *active-project-mode* 2) (check-numstr numstr 5 0 65535))))

(defun check-numstr (numstr maxdigits minval maxval)
  (let ((result nil))
    (unless (or (equal numstr "")
                (equal numstr "."))
      (multiple-value-bind (num len) (read-from-string numstr)
        (if (and (>= len 1)
                 (<= len maxdigits))
          (if (integerp num)
            (if (and (>= num minval)
                     (<= num maxval))
              (setf result t))))))
    result))

(defun bad-number-error ()
  (beep)
  (cond ((= *active-project-mode* 1) (alert-dialog "Error" "You must enter numbers in the range 0-255."   260 80))
        ((= *active-project-mode* 2) (alert-dialog "Error" "You must enter numbers in the range 0-65535." 260 80))))

(defun bound-reversal-error ()
  (beep)
  (alert-dialog "Error" "The lower bound must be smaller than the upper one." 315 80))

(defun procedure-error (errorcode)
  (beep)
  (cond ((= errorcode -3) (alert-dialog "Error" "The names of the P1 and P2 procedure definition blocks cannot be changed." 340 80))
        ((= errorcode -2) (alert-dialog "Error" "That name is either reserved or in use; please choose a different one."    340 80))
        ((= errorcode -1) (alert-dialog "Error" "You must enter at least one character."                                    240 80))))

;--------------- DIALOG-ITEM CLASSES/SSMs ------------------------------------

(defclass pict-dialog-item (dialog-item)
  ((buffer                   :initarg :buffer    :reader   buffer)))

(defmethod view-draw-contents ((view pict-dialog-item))
  (rlet ((localrect :rect :topleft  #@(0 0)
                          :botright (view-size view)))
    (gworld-copyfrom (buffer view)
                     view
                     (access-gworld-boundrect (buffer view))
                     localrect)))